{ --------------------------------------------------------
   ⮬ 㫥 ࠧ饭 ꥪ GameField, ⢥騩
   ⠭ ࠡ 祫  .
  楤 DrawField 㠫쭠 ..  ࠧ筠
   ந ⮣ ꥪ  㤥 ८।.

     ᠬ ⠢ ࠡ   ᥡ
  ⠪   .    ⠪ ࠧ:
     - 室 ᢮ 祩
     - 롨ࠥ ࠢ ᯮ ࠡ (ࠢ 
       )
     - ஢塞,    ⠢ 㤠  ࠡ
     - ᫨   ⠢   砥  ᥤ ⪨
         (BusyCell)
     -   ᫨ ,  ஡㥬 㣨 न

   ஢  ।⠢  ᥡ ⪨  ࠧ묨
  祭ﬨ.  ᢮ 室  室 砩
  ࠧ  祩 (FreeCell)  "५" 㤠.
  ᫨ 室 १⨢,   砥  "
  ࠡ" (Hit + ࠧ ࠡ),  ⨢ 砥 
  砥  ஬ (PastMove)  室 室
   祫. 祭   祫 .
    ।ਭ ⮪ "" ࠡ 
    ,     祫.
     ॠ - ⮣, 
   楫 뫠 楫 祡,   ⥣᪠.
  --------------------------------------------------------
  Copyright(c) 1997 by Jassinskaja Jana, Jelena Kuznetsova
  -------------------------------------------------------- }
Unit SeaField;

interface

const
  FieldSize = 9; { ࠧ ஢  }
  FreeCell = 0;  { ᢮ 祩 }
  Ship1 = 1;     {  ࠡ }
  Ship2 = 2;     { ன ࠡ}
  Ship3 = 3;     { ⨩ }
  Ship4 = 4;     { ⢥ }
  BusyCell = 50;  { 㦥  祩 ( ࠡ,  ࠢ 
                     ⠢ ࠡ) }
  PastMove = 100; { ஬ 室 }
  Hit = 200;      {  ࠡ +  ࠡ }
  NotAvail = 150; { 頥  砩 室  ࠭  }

type
  { ஢ ࠭⢮ }
  GameSpace = array[0..FieldSize, 0..FieldSize] of byte;
  Direction = (RightDir, DownDir);  { ⨬ ࠢ }
  PosVal = 0..FieldSize;          { ⨬ न  }

  GameFieldPtr = ^GameField;
  GameField = object
    Xcoor, Ycoor : integer;             { न ஢  }
    WorkSpace : GameSpace;      { ஢ =࠭⢮}
    constructor Init(InitX, InitY : integer);
    destructor Done;
    function GetCell(Ox, Oy : integer) : byte;   {    ⪨ }
    procedure SetCell(Ox, Oy : integer; Val : byte); { ⠢  ⪥  }
    procedure PutOnePart(Ox, Oy : PosVal; Val : byte); { ⠭  ࠡ }
    function IsAvailable(Ox, Oy : PosVal) : boolean; { 㯭  祩  ࠡ }
    { ⠢ ࠡ   }
    function PutNewShip(Ox, Oy : PosVal; ShipSize : byte; dir : Direction) : boolean;
    procedure SetUpField; { ᮧ   ⠭묨 ࠡﬨ }
    procedure DrawField; virtual; { 뢥  ࠭ ஢  }
  end;

  HumanFieldPtr = ^HumanField;
  HumanField = object(GameField)
    procedure DrawField; virtual;
  end;

  ComputerFieldPtr = ^ComputerField;
  ComputerField = object(GameField)
    procedure DrawField; virtual;
  end;

implementation

uses
  Crt;

(******************************************************************)
(*                            GAMEFIELD                           *)
(******************************************************************)
constructor GameField.Init;
begin
  Xcoor := InitX;
  Ycoor := InitY;
  FillChar(WorkSpace, SizeOf(WorkSpace), FreeCell);
end;

destructor GameField.Done;
begin
end;

{  祭   祩 }
function GameField.GetCell;
begin
  { ஢ઠ  ⨬ 祭 }
  if (Ox < 0) or (Ox > FieldSize) or
     (Oy < 0) or (Oy > FieldSize) then
    GetCell := NotAvail
  else
    GetCell := WorkSpace[Ox, Oy];
end;

{ ⠭   祩 }
procedure GameField.SetCell;
begin
  { ஢ઠ  ⨬ 祭 }
  if (Ox >= 0) and (Ox <= FieldSize) and
     (Oy >= 0) and (Oy <= FieldSize) then
    WorkSpace[Ox, Oy] := Val;
end;

procedure GameField.PutOnePart;
begin
  { ⠢  ࠡ  ᥤ ⪨ 砥   }
  WorkSpace[Ox, Oy] := Val;
  if GetCell(Ox-1, Oy-1) <> PastMove then SetCell(Ox-1, Oy-1, BusyCell);
  if GetCell(Ox+1, Oy-1) <> PastMove then SetCell(Ox+1, Oy-1, BusyCell);
  if GetCell(Ox-1, Oy+1) <> PastMove then SetCell(Ox-1, Oy+1, BusyCell);
  if GetCell(Ox+1, Oy+1) <> PastMove then SetCell(Ox+1, Oy+1, BusyCell);
end;

function GameField.IsAvailable;
{ ஢塞 㯭 ⪨  ⠭ ࠡ
  ( ਬ ࠡ) }
var
  i, j : integer;
begin
  IsAvailable := TRUE;
  for i := 0 to 2 do
    for j := 0 to 2 do
      { ᫨   ,    }
      if GetCell(Ox-1+i, Oy-1+j) in [Ship1, Ship2, Ship3, Ship4] then
        IsAvailable := FALSE;
end;

function GameField.PutNewShip;
{ ⠭ ࠡ
  頥 TRUE, ᫨ 㤠 ⠢ ࠡ }
var
  ix, iy : integer; { ६ ६  न⠬ ࠡ }
  i : integer;      { 稪 }
  flag : boolean;  { 㪠뢠   ⠭ ࠡ }
begin
  ix := 0; iy := 0;
  flag := TRUE;

  { ஢塞,   ࠡ    ⮩ ᪫ }
  case dir of
    RightDir : if (Ox + ShipSize > FieldSize+1) then flag := FALSE;
    DownDir  : if (Oy + ShipSize > FieldSize+1) then flag := FALSE;
  end;

  { ஢塞    㦭 祩 }
  if flag and IsAvailable(Ox, Oy) then begin
    for i := 1 to ShipSize-1 do begin
      {   ࠢ 㢥稢 ix }
      if dir = RightDir then
        Inc(ix)
      {  ᫨  - iy }
      else
        Inc(iy);
      {   ⠢ ࠡ? }
      if not IsAvailable(Ox+ix, Oy+iy) then
        flag := FALSE;
    end; { for }
  end
  else
    flag := FALSE;

  { ⠢塞 ࠡ }
  if flag then begin
    case dir of
      RightDir : for i := 0 to ShipSize-1 do SetCell(Ox + i, Oy, ShipSize);
      DownDir  : for i := 0 to ShipSize-1 do SetCell(Ox, Oy + i, ShipSize);
    end;

  end;
  PutNewShip := flag;
end;

procedure GameField.SetUpField;
{ ⮢  ࠦ }
var
  rx, ry : integer;      { 砩 롨ࠥ न  ࠡ }
  d : Direction;         { ࠢ ᯮ ࠡ }
  i, j : byte;           { 稪: i - ࠧ ࠡ; j - - ࠡ }
begin
  for i := 4 downto 1 do
    for j := 4 downto i do
      {       㤠 ⠢ ࠡ }
      repeat
        rx := Random(FieldSize+1);
        ry := Random(FieldSize+1);
        d := Direction(random(2));
      until PutNewShip(rx, ry, i, d);
end;

procedure GameField.DrawField;
begin
end;

(*******************************************************************)
(*                          HumanField                             *)
(*******************************************************************)
{ 뢮  ࠭ ஢  ப }
procedure HumanField.DrawField;
var
  i, j : integer;
begin
  { ⠭   뢮  }
  Window(Xcoor, Ycoor, Xcoor + FieldSize * 2 + 3, Ycoor + FieldSize + 2);
  GotoXY(3, 1);
  { 뢮  न X }
  for i := 0 to FieldSize do
    Write(i:2);
  { 㥬 न Y  ࠡ  襬  }
  for i := 0 to FieldSize do begin
    GotoXY(1, 2 + i);
    Write(i, '  ');
    for j := 0 to FieldSize do begin
      case WorkSpace[j, i] of
        FreeCell : Write('.');
        Ship1 : Write('1');
        Ship2 : Write('2');
        Ship3 : Write('3');
        Ship4 : Write('4');
        PastMove : Write('*');
        Hit..255 : Write('X');
        BusyCell : write('.');
      end;
      Write(' ');
    end;
  end;
  Window(1, 1, 80, 25); { ⠭  ࠧ  }
end;


(*******************************************************************)
(*                       ComputerField                             *)
(*******************************************************************)
{ 뢮  ࠭ ஢   }
procedure ComputerField.DrawField;
var
  i, j : integer;
begin
  Window(Xcoor, Ycoor, Xcoor + FieldSize * 2 + 3, Ycoor + FieldSize + 2);
  GotoXY(3, 1);
  for i := 0 to FieldSize do
    Write(i:2);
  for i := 0 to FieldSize do begin
    GotoXY(1, 2 + i);
    Write(i, '  ');
    for j := 0 to FieldSize do begin
      { ⭮   ࠡ     }
      case WorkSpace[j, i] of
        FreeCell, BusyCell : Write('.');
        Ship1, Ship2, Ship3, Ship4 : Write('.');
        PastMove : Write('*');
        Hit..255 : Write(WorkSpace[j, i]-Hit);
      end;
      Write(' ');
    end;
  end;
  Window(1, 1, 80, 25);
end;

end.