
import java.util.*;
import java.applet.*;
import java.awt.*;
import java.awt.image.*;

public class manymoons extends Applet implements Runnable {

  int i, j;
  int NUM;
  double x[] = new double[10];
  double y[] = new double[10];
  double r[] = new double[10];
  double vx[] = new double[10];
  double vy[] = new double[10];
  int ix[] = new int[10];
  int iy[] = new int[10];
  int ir[] = new int[10];
  double m[] = new double[10];
  double C = 0.005;
  double G = 9.8;
  double SCALE = 100.0;
  double VSCALE = 200.0;
  double R, Rm;
  double RMIN = 40.0;
  Random rr = new Random();
  double Sx, Sy, Svx, Svy, Sm;
  Color mcol[] = new Color[10];
  Color bcol = Color.pink;
  Color txtcol = new Color(0, 64, 64);

  Image holdImage;
  Graphics holdGraphics;

  public void init() {

    Sx = Sy = Svx = Svy = Sm = 0;
    NUM = 5 + ( Math.abs(rr.nextInt()) % 5 );
    // just as good: NUM = 5 + (int) (Math.random() * 5.0);
    for (i=0; i<NUM; i++) {
      x[i] = SCALE * rr.nextGaussian();
      y[i] = SCALE * rr.nextGaussian();
      vx[i] = VSCALE * rr.nextGaussian();
      vy[i] = VSCALE * rr.nextGaussian();
      r[i] = 10 + 30 * Math.random();
      m[i] = r[i]*r[i]*r[i];
      mcol[i] = new Color( Math.abs(rr.nextInt()) % 128,
      			Math.abs(rr.nextInt()) % 128, 
			Math.abs(rr.nextInt()) % 178);
      
      Sx = Sx + m[i]*x[i];
      Sy = Sy + m[i]*y[i];
      Svx = Svx + m[i]*vx[i];
      Svy = Svy + m[i]*vy[i];
      Sm = Sm + m[i];
    } 

    for (i=0; i<NUM; i++) {
      x[i] = x[i] - (Sx / Sm) + (size().width/2.0);
      y[i] = y[i] - (Sy / Sm) + (size().height/2.0);
      vx[i] = vx[i] - (Svx / Sm) ;
      vy[i] = vy[i] - (Svy / Sm) ;
    }

    holdImage = createImage(size().width, size().height);
    holdGraphics = holdImage.getGraphics();

  }

  public void run() {
      while (true) {
	try {
	  Thread.currentThread().sleep(40);
        } catch (InterruptedException e) {
          // break;
        }
	for (i=0; i<NUM; i++) {
	  for (j=0; j<NUM; j++) {
	    if ( i!=j ) {
              R = java.lang.Math.sqrt( (x[i]-x[j])*(x[i]-x[j]) 
			+ (y[i]-y[j])*(y[i]-y[j]) );
              Rm = Math.max(RMIN, R);
	      vx[i] = vx[i] + G*m[j]*(x[j]-x[i])/(R*Rm*Rm);
	      vy[i] = vy[i] + G*m[j]*(y[j]-y[i])/(R*Rm*Rm);
            }
	  }
	}

	for (i=0; i<NUM; i++) {
	  x[i] = x[i] + C*vx[i];
	  y[i] = y[i] + C*vy[i];
	}

        repaint();
      }
  }

  public void paint (Graphics g) {
    g.setColor(bcol);
    g.fillRect(0,0,size().width,size().height);
    g.setColor(txtcol);
    if (NUM == 8)
      g.drawString("An " + NUM + "-body system!", 30, 30);
    else
      g.drawString("A " + NUM + "-body system!", 30, 30);
    for (i=0; i<NUM; i++) {
      ix[i] = (int) Math.round(x[i] - (r[i]/2.0));
      iy[i] = (int) Math.round(y[i] - (r[i]/2.0));
      ir[i] = (int) Math.round(r[i]);
      g.setColor(mcol[i]);
      g.fillOval(ix[i],iy[i],ir[i],ir[i]);
    }
  }

  public void update(Graphics g) {
    paint(holdGraphics);
    g.drawImage(holdImage, 0, 0, this);
  }

  public boolean keyDown(Event evt, int key) {
    char keystroke = (char) key;
    if (keystroke == 'R') {  // Restart!
      init();
    }
    if (keystroke == 'j') {
      for (i=0; i<NUM; i++) {
	y[i] = y[i] - 40;
      }
    }
    if (keystroke == 'k') {
      for (i=0; i<NUM; i++) {
	y[i] = y[i] + 40;
      }
    }
    if (keystroke == 'h') {
      for (i=0; i<NUM; i++) {
	x[i] = x[i] + 40;
      }
    }
    if (keystroke == 'l') {
      for (i=0; i<NUM; i++) {
	x[i] = x[i] - 40;
      }
    }
    return true;
  }


  Thread t;

  public void start() {
    t = new Thread(this);
    t.start();
  }

  public void stop() {
    t.stop();
    t = null;
  }

}

